import entmob

# projectiles probably shouldn't be a subclass of mobs...
class EntSimpleProjectile(entmob.EntMob):
    
    def __init__(self, name, damage, time_left=-1):
        """
        Simple projectile that deals coll_dmg to entities it collides with.
            img_angle in radians
        """
        super(EntSimpleProjectile, self).__init__(name)
        self.coll_dmg = damage
        self.img_angle = 0
        self.const_angle = False
        self.time_left = time_left
        self._already_hit = set()
        
    def time_update(self, time_passed):
        super(EntSimpleProjectile, self).time_update(time_passed)
        self.img_angle = self.phys_body.angle
        if self.time_left != -1:
            self.time_left -= time_passed
            if self.time_left < 0: self.dead = True
        
    def on_touch(self, other_body, coll_points):
        if other_body in self._already_hit: return
        self._already_hit.add(other_body)
        if other_body.userData:
            other_body.userData['ent'].take_damage(self.coll_dmg)
