class GameEntity(object):
    """
    Base GameEntity class. Has just barely enough for drawing.
        loc          : location on map in meters.
        size         : size of GameEntity in meters
        imagesize    : image size for drawing in pixels
        curr_map     : current GameMap
    """
    
    def __init__(self, name):
        self.name = name
        self.loc = (0, 0)
        self.imagesize = (32, 32)
        self.size = (2, 2)
        self.curr_map = None
        
    def time_update(self, time_passed):
        pass
            
    def on_touch(self, other_body, coll_points):
        pass
