"""
main.py

"The Last Thing I Do" for PyWeek 16 'nemesis'.

KNOWN BUGS/ISSUES:
1. The mobs (red boxes) fly off really quickly when they die. Decided not to debug this because I found it really funny.
"""

import pygame
from game.gameengine import GameEngine
from lastthinggui import LastThingGUI
from usercontrol import UserControl

def run_game():
    game = GameEngine()
    gui = LastThingGUI(game)
    control = UserControl(game)
    # Game Loop
    FRAME_RATE = 60
    clock = pygame.time.Clock()
    time_passed = 0
    while control.running:
        control.time_update(time_passed)
        game.time_update(time_passed)
        gui.time_update(time_passed)
        time_passed = clock.tick(FRAME_RATE)
    pygame.quit()

if __name__ == "__main__":
    run_game()
