import pygame
import math
import lastthinggui

class UserControl(object):
    
    ACTION_MAP = {pygame.K_w : 'move_up',
                  pygame.K_s : 'move_down',
                  pygame.K_a : 'move_left',
                  pygame.K_d : 'move_right'}
    
    def __init__(self, model):
        """Takes GameEngine as model."""
        self.running = True
        self.model = model
    
    def time_update(self, time_passed):
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                self.running = False
            elif event.type == pygame.MOUSEBUTTONDOWN and not self.model.pchar.dead:
                # TODO: move the conversion into GUI class
                mouse_loc = (event.pos[0], event.pos[1])
                pc_loc = (lastthinggui.LastThingGUI.SCREEN_WIDTH/2, 
                          lastthinggui.LastThingGUI.SCREEN_HEIGHT/2)
                angle = math.atan2(mouse_loc[1] - pc_loc[1], mouse_loc[0] - pc_loc[0])
                self.model.pchar.attack(-angle)
        key_states = pygame.key.get_pressed()
        self.model.pchar.dir_vec.x = 0
        self.model.pchar.dir_vec.y = 0
        for key in self.ACTION_MAP:
            if key_states[key]:
                if self.ACTION_MAP[key] == 'move_up':
                    self.model.pchar.dir_vec.y -= 1
                elif self.ACTION_MAP[key] == 'move_down':
                    self.model.pchar.dir_vec.y += 1
                if self.ACTION_MAP[key] == 'move_left':
                    self.model.pchar.dir_vec.x -= 1
                elif self.ACTION_MAP[key] == 'move_right':
                    self.model.pchar.dir_vec.x += 1